/* @clake/react-bootstrap4 v2.4.2 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-06T15:32:53+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Icon = void 0;

var _react = _interopRequireDefault(require("react"));

var _bind = _interopRequireDefault(require("classnames/bind"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Icon =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Icon, _React$PureComponent);

  function Icon(props) {
    var _this$props$icon;

    var _this;

    _classCallCheck(this, Icon);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Icon).call(this, props));
    _this.state = {
      icon: (_this$props$icon = _this.props.icon) !== null && _this$props$icon !== void 0 ? _this$props$icon : ''
    };
    return _this;
  }

  _createClass(Icon, [{
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var _nextProps$icon;

      // this.setState({
      //     icon: nextProps.icon,
      // });
      this.setIcon((_nextProps$icon = nextProps.icon) !== null && _nextProps$icon !== void 0 ? _nextProps$icon : '');
    }
  }, {
    key: "setIcon",
    value: function setIcon(icon) {
      this.setState({
        icon: icon
      });
    }
  }, {
    key: "getClasses",
    value: function getClasses() {
      if (this.props.bs) {
        return this.getBsClasses();
      }

      var base;

      switch (this.props.iconType) {
        case 'regular':
          base = 'far';
          break;

        case 'light':
          base = 'fal';
          break;

        case 'brands':
          base = 'fab';
          break;

        default:
          base = 'fas';
      }

      if (this.state.icon) {
        base = (0, _bind["default"])(base, 'fa-' + this.state.icon);
      }

      if (this.props.spin) {
        base = (0, _bind["default"])(base, 'fa-spin');
      }

      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "getBsClasses",
    value: function getBsClasses() {
      var base;

      if (this.state.icon) {
        base = (0, _bind["default"])(base, this.state.icon);
      }

      return (0, _bind["default"])(base, this.props.className);
    }
  }, {
    key: "render",
    value: function render() {
      return _react["default"].createElement("i", _extends({}, this.props, {
        className: this.getClasses(),
        onClick: this.props.onClick
      }));
    }
  }]);

  return Icon;
}(_react["default"].PureComponent);

exports.Icon = Icon;

_defineProperty(Icon, "defaultProps", {
  iconType: 'solid',
  icon: ''
});

var _default = Icon;
exports["default"] = _default;
//# sourceMappingURL=Icon.js.map
